diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/include/net/route.h linux-2.6.19.2-vs2.2.0-rc7.1/include/net/route.h
--- linux-2.6.19.2-vs2.2.0-rc7/include/net/route.h	2006-12-02 02:59:41 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/include/net/route.h	2007-01-18 04:59:41 +0100
@@ -228,10 +228,10 @@ static inline int ip_route_connect(struc
 		err = ip_find_src(nx_info, rp, &fl);
 		if (err)
 			return err;
-		if (fl.fl4_dst == IPI_LOOPBACK && !vx_check(0, VS_ADMIN))
+		if (fl.fl4_dst == IPI_LOOPBACK && !nx_check(0, VS_ADMIN))
 			fl.fl4_dst = nx_info->ipv4[0];
 #ifdef CONFIG_VSERVER_REMAP_SADDR
-		if (fl.fl4_src == IPI_LOOPBACK && !vx_check(0, VS_ADMIN))
+		if (fl.fl4_src == IPI_LOOPBACK && !nx_check(0, VS_ADMIN))
 			fl.fl4_src = nx_info->ipv4[0];
 #endif
 	}
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/kernel/vserver/network.c linux-2.6.19.2-vs2.2.0-rc7.1/kernel/vserver/network.c
--- linux-2.6.19.2-vs2.2.0-rc7/kernel/vserver/network.c	2006-12-06 21:03:02 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/kernel/vserver/network.c	2007-01-18 04:59:17 +0100
@@ -557,7 +557,7 @@ int vc_task_nid(uint32_t id, void __user
 	if (id) {
 		struct task_struct *tsk;
 
-		if (!vx_check(0, VS_ADMIN|VS_WATCH))
+		if (!nx_check(0, VS_ADMIN|VS_WATCH))
 			return -EPERM;
 
 		read_lock(&tasklist_lock);
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/kernel/vserver/switch.c linux-2.6.19.2-vs2.2.0-rc7.1/kernel/vserver/switch.c
--- linux-2.6.19.2-vs2.2.0-rc7/kernel/vserver/switch.c	2007-01-10 17:35:47 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/kernel/vserver/switch.c	2007-01-18 04:48:10 +0100
@@ -419,7 +419,7 @@ long do_vserver(uint32_t cmd, uint32_t i
 
 	case VCMD_ctx_create_v0:
 #endif
-	/* will go away when admin is a cap */
+	/* will go away when spectator is a cap */
 	case VCMD_ctx_migrate_v0:
 	case VCMD_ctx_migrate:
 		if (id == 1) {
@@ -429,6 +429,15 @@ long do_vserver(uint32_t cmd, uint32_t i
 		}
 		break;
 
+	/* will go away when spectator is a cap */
+	case VCMD_net_migrate:
+		if (id == 1) {
+			current->nid = 1;
+			ret = 1;
+			goto out;
+		}
+		break;
+
 	/* legacy special casing */
 	case VCMD_set_space_v0:
 		id = -1;
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/net/ipv4/raw.c linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv4/raw.c
--- linux-2.6.19.2-vs2.2.0-rc7/net/ipv4/raw.c	2006-12-04 05:07:18 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv4/raw.c	2007-01-18 04:58:28 +0100
@@ -336,7 +336,7 @@ static int raw_send_hdrinc(struct sock *
 	}
 
 	err = -EPERM;
-	if (!vx_check(0, VS_ADMIN) && !capable(CAP_NET_RAW)
+	if (!nx_check(0, VS_ADMIN) && !capable(CAP_NET_RAW)
 		&& (!addr_in_nx_info(sk->sk_nx_info, iph->saddr)))
 		goto error_free;
 
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/net/ipv4/udp.c linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv4/udp.c
--- linux-2.6.19.2-vs2.2.0-rc7/net/ipv4/udp.c	2007-01-11 16:26:05 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv4/udp.c	2007-01-18 04:57:33 +0100
@@ -645,10 +645,10 @@ int udp_sendmsg(struct kiocb *iocb, stru
 			err = ip_find_src(nxi, &rt, &fl);
 			if (err)
 				goto out;
-			if (daddr == IPI_LOOPBACK && !vx_check(0, VS_ADMIN))
+			if (daddr == IPI_LOOPBACK && !nx_check(0, VS_ADMIN))
 				daddr = fl.fl4_dst = nxi->ipv4[0];
 #ifdef CONFIG_VSERVER_REMAP_SADDR
-			if (saddr == IPI_LOOPBACK && !vx_check(0, VS_ADMIN))
+			if (saddr == IPI_LOOPBACK && !nx_check(0, VS_ADMIN))
 				saddr = fl.fl4_src = nxi->ipv4[0];
 #endif
 		}
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/net/ipv6/addrconf.c linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv6/addrconf.c
--- linux-2.6.19.2-vs2.2.0-rc7/net/ipv6/addrconf.c	2007-01-11 16:26:05 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/net/ipv6/addrconf.c	2007-01-18 05:00:02 +0100
@@ -2732,7 +2732,7 @@ static int if6_seq_show(struct seq_file 
 	struct inet6_ifaddr *ifp = (struct inet6_ifaddr *)v;
 
 	/* no ipv6 inside a vserver for now */
-	if (vx_check(0, VS_ADMIN|VS_WATCH))
+	if (nx_check(0, VS_ADMIN|VS_WATCH))
 		seq_printf(seq,
 		   NIP6_SEQFMT " %02x %02x %02x %02x %8s\n",
 		   NIP6(ifp->addr),
diff -NurpP --minimal linux-2.6.19.2-vs2.2.0-rc7/net/socket.c linux-2.6.19.2-vs2.2.0-rc7.1/net/socket.c
--- linux-2.6.19.2-vs2.2.0-rc7/net/socket.c	2006-12-04 05:08:37 +0100
+++ linux-2.6.19.2-vs2.2.0-rc7.1/net/socket.c	2007-01-18 05:00:17 +0100
@@ -1090,7 +1090,7 @@ static int __sock_create(int family, int
 		return -EINVAL;
 
 	/* disable IPv6 inside vservers for now */
-	if (family == PF_INET6 && !vx_check(0, VS_ADMIN))
+	if (family == PF_INET6 && !nx_check(0, VS_ADMIN))
 		return -EAFNOSUPPORT;
 
 	/* Compatibility.