diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/avr32/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/avr32/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/avr32/mm/fault.c	2009-09-10 15:25:20.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/avr32/mm/fault.c	2009-09-29 17:32:09.000000000 +0200
@@ -216,7 +216,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: Killing process %s\n", tsk->comm);
+	printk("VM: Killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/cris/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/cris/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/cris/mm/fault.c	2009-09-10 15:25:21.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/cris/mm/fault.c	2009-09-29 17:25:13.000000000 +0200
@@ -245,7 +245,8 @@ do_page_fault(unsigned long address, str
 
  out_of_memory:
 	up_read(&mm->mmap_sem);
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/frv/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/frv/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/frv/mm/fault.c	2009-09-10 15:25:22.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/frv/mm/fault.c	2009-09-29 17:25:48.000000000 +0200
@@ -257,7 +257,8 @@ asmlinkage void do_page_fault(int datamm
  */
  out_of_memory:
 	up_read(&mm->mmap_sem);
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	if (user_mode(__frame))
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/ia64/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/ia64/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/ia64/mm/fault.c	2009-09-10 16:11:43.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/ia64/mm/fault.c	2009-09-29 17:26:21.000000000 +0200
@@ -282,7 +282,8 @@ ia64_do_page_fault (unsigned long addres
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk(KERN_CRIT "VM: killing process %s\n", current->comm);
+	printk(KERN_CRIT "VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/m32r/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/m32r/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/m32r/mm/fault.c	2009-09-10 15:25:23.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/m32r/mm/fault.c	2009-09-29 17:26:48.000000000 +0200
@@ -276,7 +276,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if (error_code & ACE_USERMODE)
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/m68k/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/m68k/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/m68k/mm/fault.c	2009-09-10 15:25:23.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/m68k/mm/fault.c	2009-09-29 17:27:45.000000000 +0200
@@ -186,7 +186,8 @@ out_of_memory:
 		goto survive;
 	}
 
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/microblaze/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/microblaze/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/microblaze/mm/fault.c	2009-09-10 15:25:24.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/microblaze/mm/fault.c	2009-09-29 17:28:08.000000000 +0200
@@ -279,7 +279,8 @@ out_of_memory:
 		goto survive;
 	}
 	up_read(&mm->mmap_sem);
-	printk(KERN_WARNING "VM: killing process %s\n", current->comm);
+	printk(KERN_WARNING "VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	bad_page_fault(regs, address, SIGKILL);
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/mn10300/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/mn10300/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/mn10300/mm/fault.c	2009-09-10 15:25:39.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/mn10300/mm/fault.c	2009-09-29 17:28:34.000000000 +0200
@@ -339,7 +339,8 @@ no_context:
 out_of_memory:
 	up_read(&mm->mmap_sem);
 	monitor_signal(regs);
-	printk(KERN_ALERT "VM: killing process %s\n", tsk->comm);
+	printk(KERN_ALERT "VM: killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if ((fault_code & MMUFCR_xFC_ACCESS) == MMUFCR_xFC_ACCESS_USR)
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/s390/lib/uaccess_pt.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/s390/lib/uaccess_pt.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/s390/lib/uaccess_pt.c	2009-09-10 15:25:43.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/s390/lib/uaccess_pt.c	2009-09-29 17:29:02.000000000 +0200
@@ -90,7 +90,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	return ret;
 
 out_sigbus:
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/sh/mm/fault_32.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/sh/mm/fault_32.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/sh/mm/fault_32.c	2009-09-10 15:25:45.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/sh/mm/fault_32.c	2009-09-29 17:29:36.000000000 +0200
@@ -246,7 +246,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/sh/mm/tlbflush_64.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/sh/mm/tlbflush_64.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/sh/mm/tlbflush_64.c	2009-09-10 15:25:45.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/sh/mm/tlbflush_64.c	2009-09-29 17:29:54.000000000 +0200
@@ -306,7 +306,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, task_pid_nr(tsk), tsk->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/xtensa/mm/fault.c linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/xtensa/mm/fault.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/arch/xtensa/mm/fault.c	2009-09-10 15:25:48.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/arch/xtensa/mm/fault.c	2009-09-29 17:30:14.000000000 +0200
@@ -151,7 +151,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, task_pid_nr(current), current->xid);
 	if (user_mode(regs))
 		do_group_exit(SIGKILL);
 	bad_page_fault(regs, address, SIGKILL);
diff -NurpP --minimal linux-2.6.31.1-vs2.3.0.36.14-pre8/mm/oom_kill.c linux-2.6.31.1-vs2.3.0.36.14-pre9/mm/oom_kill.c
--- linux-2.6.31.1-vs2.3.0.36.14-pre8/mm/oom_kill.c	2009-09-10 16:11:43.000000000 +0200
+++ linux-2.6.31.1-vs2.3.0.36.14-pre9/mm/oom_kill.c	2009-09-29 17:34:31.000000000 +0200
@@ -337,8 +337,8 @@ static void __oom_kill_task(struct task_
 	}
 
 	if (verbose)
-		printk(KERN_ERR "Killed process %d:#%u (%s)\n",
-				task_pid_nr(p), p->xid, p->comm);
+		printk(KERN_ERR "Killed process %s(%d:#%u)\n",
+			p->comm, task_pid_nr(p), p->xid);
 
 	/*
 	 * We give our sacrificial lamb high priority and access to
@@ -422,8 +422,8 @@ static int oom_kill_process(struct task_
 		return 0;
 	}
 
-	printk(KERN_ERR "%s: kill process %d:#%u (%s) score %li or a child\n",
-				message, task_pid_nr(p), p->xid, p->comm, points);
+	printk(KERN_ERR "%s: kill process %s(%d:#%u) score %li or a child\n",
+		message, p->comm, task_pid_nr(p), p->xid, points);
 
 	/* Try to kill a child first */
 	list_for_each_entry(c, &p->children, sibling) {