diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/alpha/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/alpha/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/alpha/mm/fault.c	2006-11-07 03:18:12 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/alpha/mm/fault.c	2007-02-28 18:22:14 +0100
@@ -198,8 +198,8 @@ do_page_fault(unsigned long address, uns
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk(KERN_ALERT "VM: killing process %s(%d)\n",
-	       current->comm, current->pid);
+	printk(KERN_ALERT "VM: killing process %s(%d:#%u)\n",
+	       current->comm, current->pid, current->xid);
 	if (!user_mode(regs))
 		goto no_context;
 	do_exit(SIGKILL);
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/arm/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/arm/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/arm/mm/fault.c	2006-11-07 03:18:14 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/arm/mm/fault.c	2007-02-28 18:22:55 +0100
@@ -267,7 +267,8 @@ do_page_fault(unsigned long addr, unsign
 		 * happened to us that made us unable to handle
 		 * the page fault gracefully.
 		 */
-		printk("VM: killing process %s\n", tsk->comm);
+		printk("VM: killing process %s(%d:#%u)\n",
+			tsk->comm, tsk->pid, tsk->xid);
 		do_exit(SIGKILL);
 		return 0;
 
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/i386/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/i386/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/i386/mm/fault.c	2006-11-07 03:18:15 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/i386/mm/fault.c	2007-02-28 18:23:35 +0100
@@ -594,7 +594,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (error_code & 4)
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/mips/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/mips/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/mips/mm/fault.c	2006-11-07 03:18:21 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/mips/mm/fault.c	2007-02-28 18:24:15 +0100
@@ -176,7 +176,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/parisc/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/parisc/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/parisc/mm/fault.c	2006-11-08 04:57:42 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/parisc/mm/fault.c	2007-02-28 18:24:50 +0100
@@ -265,7 +265,8 @@ no_context:
 
   out_of_memory:
 	up_read(&mm->mmap_sem);
-	printk(KERN_CRIT "VM: killing process %s\n", current->comm);
+	printk(KERN_CRIT "VM: killing process %s(%d:#%u)\n",
+		current->comm, current->pid, current->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/powerpc/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/powerpc/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/powerpc/mm/fault.c	2006-11-07 03:18:23 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/powerpc/mm/fault.c	2007-02-28 18:25:26 +0100
@@ -391,7 +391,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, current->pid, current->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	return SIGKILL;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/ppc/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/ppc/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/ppc/mm/fault.c	2006-11-07 03:18:24 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/ppc/mm/fault.c	2007-02-28 18:26:04 +0100
@@ -296,7 +296,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, current->pid, current->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	return SIGKILL;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/s390/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/s390/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/s390/mm/fault.c	2006-11-07 03:18:28 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/s390/mm/fault.c	2007-02-28 18:26:38 +0100
@@ -358,7 +358,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (regs->psw.mask & PSW_MASK_PSTATE)
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/sh/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/sh/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/sh/mm/fault.c	2006-11-07 03:18:29 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/sh/mm/fault.c	2007-02-28 18:27:11 +0100
@@ -154,7 +154,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/sh64/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/sh64/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/sh64/mm/fault.c	2006-11-08 04:57:42 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/sh64/mm/fault.c	2007-02-28 18:27:43 +0100
@@ -331,7 +331,8 @@ out_of_memory:
 		down_read(&mm->mmap_sem);
 		goto survive;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/sparc/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/sparc/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/sparc/mm/fault.c	2006-01-03 17:29:19 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/sparc/mm/fault.c	2007-02-28 18:28:15 +0100
@@ -368,7 +368,8 @@ no_context:
  */
 out_of_memory:
 	up_read(&mm->mmap_sem);
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (from_user)
 		do_exit(SIGKILL);
 	goto no_context;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/sparc64/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/sparc64/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/sparc64/mm/fault.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/sparc64/mm/fault.c	2007-02-28 18:29:18 +0100
@@ -484,7 +484,8 @@ handle_kernel_fault:
 out_of_memory:
 	insn = get_fault_insn(regs, insn);
 	up_read(&mm->mmap_sem);
-	printk("VM: killing process %s\n", current->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		current->comm, current->pid, current->xid);
 	if (!(regs->tstate & TSTATE_PRIV))
 		do_exit(SIGKILL);
 	goto handle_kernel_fault;
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/um/kernel/trap.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/um/kernel/trap.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/um/kernel/trap.c	2006-11-07 03:18:31 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/um/kernel/trap.c	2007-02-28 18:29:52 +0100
@@ -193,7 +193,8 @@ unsigned long segv(struct faultinfo fi, 
                 current->thread.arch.faultinfo = fi;
 		force_sig_info(SIGBUS, &si, current);
 	} else if (err == -ENOMEM) {
-		printk("VM: killing process %s\n", current->comm);
+		printk("VM: killing process %s(%d:#%u)\n",
+			current->comm, current->pid, current->xid);
 		do_exit(SIGKILL);
 	} else {
 		BUG_ON(err != -EFAULT);
diff -NurpP --minimal linux-2.6.19.5-vs2.2.0-rc15/arch/x86_64/mm/fault.c linux-2.6.19.5-vs2.2.0-rc15.1/arch/x86_64/mm/fault.c
--- linux-2.6.19.5-vs2.2.0-rc15/arch/x86_64/mm/fault.c	2006-11-08 04:57:42 +0100
+++ linux-2.6.19.5-vs2.2.0-rc15.1/arch/x86_64/mm/fault.c	2007-02-28 18:30:24 +0100
@@ -584,7 +584,8 @@ out_of_memory:
 		yield();
 		goto again;
 	}
-	printk("VM: killing process %s\n", tsk->comm);
+	printk("VM: killing process %s(%d:#%u)\n",
+		tsk->comm, tsk->pid, tsk->xid);
 	if (error_code & 4)
 		do_exit(SIGKILL);
 	goto no_context;